
/*
#*********************************************************************
# feasm.asm
#       this contains the asm functions required by fepcx.
#   compiles under tasm 3.0 with the switches specified in the makefile.
#       this version assumes stack calling convention, in order to work
# properly with gcc.  it also reverses the _direction.
# data directive may be incorrect.
#*********************************************************************
#     copyright 1995 by jeff lait.
#     permission granted to members of the a-life team to hack/modify at
# their whim :>
#*********************************************************************
# notes:
#   this current version is for 320x200.  it basically does all writes to
# an offscreen buffer which is then blitted over via blitscreen.
#   a vesa version will probably use page flipping and do all writes directly
# on screen to reduce bandwidth...
#   the timer isn't yet hooked in.
#*********************************************************************/


#*********************************************************************
# functions:
#*********************************************************************
	.globl  _FEASM_DrawSquare       # dest, width, height.
	.globl  _FEASM_Init                     # x, ylookup, keytable.
	.globl  _FEASM_ShutDown
	.globl  _FEASM_DrawTransSquare  # dest, source
	.globl  _FEASM_SetGraph         # int mode
	.globl  _FEASM_BlitScreen       # int dest, int source, int skip

 /* 3761 fps for 32x32 trans. */
	.globl  _FEASM_DrawRotated     /* int dest, int source, int *edgedata */
	.globl  _FEASM_MoveStars      /*  int dest,int numstars,int *stardata */
	.globl  _FEASM_InitStars    /*  int seed, int num, int *data */

.data   

#*********************************************************************
# equates
#*********************************************************************
	spritew =       32
	spriteh =       32
	virtw   =       12
	virth   =       9
	spritesz        =       1024

#*********************************************************************
# data
#*********************************************************************
keytable:       .long   0
xlookup:        .long   0
ylookup:        .long   0
oldkeyoff:      .long   0
oldkeyseg:      .value  0
random: .long   0x12345678

#*********************************************************************
# jump table used by unrolled loop:
#*********************************************************************
jumptable520:
	.long   jump0table520
	.long   jump1table520
	.long   jump2table520
	.long   jump3table520

#*********************************************************************
# multiplication lookup.  hey, there must be a better way to generate
# this under tasm 3.0 - any suggestions???
#*********************************************************************
/* I also don't know a better way than this to make a multiplication
   table in the gnu assembler..simply wrote a C program to generate it
   :) <MF> */

ddmulttable:
.long virtw*spritew*(0*9+0)
.long virtw*spritew*(0*9+1)
.long virtw*spritew*(0*9+2)
.long virtw*spritew*(0*9+3)
.long virtw*spritew*(0*9+4)
.long virtw*spritew*(0*9+5)
.long virtw*spritew*(0*9+6)
.long virtw*spritew*(0*9+7)
.long virtw*spritew*(0*9+8)
.long virtw*spritew*(1*9+0)
.long virtw*spritew*(1*9+1)
.long virtw*spritew*(1*9+2)
.long virtw*spritew*(1*9+3)
.long virtw*spritew*(1*9+4)
.long virtw*spritew*(1*9+5)
.long virtw*spritew*(1*9+6)
.long virtw*spritew*(1*9+7)
.long virtw*spritew*(1*9+8)
.long virtw*spritew*(2*9+0)
.long virtw*spritew*(2*9+1)
.long virtw*spritew*(2*9+2)
.long virtw*spritew*(2*9+3)
.long virtw*spritew*(2*9+4)
.long virtw*spritew*(2*9+5)
.long virtw*spritew*(2*9+6)
.long virtw*spritew*(2*9+7)
.long virtw*spritew*(2*9+8)
.long virtw*spritew*(3*9+0)
.long virtw*spritew*(3*9+1)
.long virtw*spritew*(3*9+2)
.long virtw*spritew*(3*9+3)
.long virtw*spritew*(3*9+4)
.long virtw*spritew*(3*9+5)
.long virtw*spritew*(3*9+6)
.long virtw*spritew*(3*9+7)
.long virtw*spritew*(3*9+8)
.long virtw*spritew*(4*9+0)
.long virtw*spritew*(4*9+1)
.long virtw*spritew*(4*9+2)
.long virtw*spritew*(4*9+3)
.long virtw*spritew*(4*9+4)
.long virtw*spritew*(4*9+5)
.long virtw*spritew*(4*9+6)
.long virtw*spritew*(4*9+7)
.long virtw*spritew*(4*9+8)
.long virtw*spritew*(5*9+0)
.long virtw*spritew*(5*9+1)
.long virtw*spritew*(5*9+2)
.long virtw*spritew*(5*9+3)
.long virtw*spritew*(5*9+4)
.long virtw*spritew*(5*9+5)
.long virtw*spritew*(5*9+6)
.long virtw*spritew*(5*9+7)
.long virtw*spritew*(5*9+8)
.long virtw*spritew*(6*9+0)
.long virtw*spritew*(6*9+1)
.long virtw*spritew*(6*9+2)
.long virtw*spritew*(6*9+3)
.long virtw*spritew*(6*9+4)
.long virtw*spritew*(6*9+5)
.long virtw*spritew*(6*9+6)
.long virtw*spritew*(6*9+7)
.long virtw*spritew*(6*9+8)
.long virtw*spritew*(7*9+0)
.long virtw*spritew*(7*9+1)
.long virtw*spritew*(7*9+2)
.long virtw*spritew*(7*9+3)
.long virtw*spritew*(7*9+4)
.long virtw*spritew*(7*9+5)
.long virtw*spritew*(7*9+6)
.long virtw*spritew*(7*9+7)
.long virtw*spritew*(7*9+8)
.long virtw*spritew*(8*9+0)
.long virtw*spritew*(8*9+1)
.long virtw*spritew*(8*9+2)
.long virtw*spritew*(8*9+3)
.long virtw*spritew*(8*9+4)
.long virtw*spritew*(8*9+5)
.long virtw*spritew*(8*9+6)
.long virtw*spritew*(8*9+7)
.long virtw*spritew*(8*9+8)
.long virtw*spritew*(9*9+0)
.long virtw*spritew*(9*9+1)
.long virtw*spritew*(9*9+2)
.long virtw*spritew*(9*9+3)
.long virtw*spritew*(9*9+4)
.long virtw*spritew*(9*9+5)
.long virtw*spritew*(9*9+6)
.long virtw*spritew*(9*9+7)
.long virtw*spritew*(9*9+8)
.long virtw*spritew*(10*9+0)
.long virtw*spritew*(10*9+1)
.long virtw*spritew*(10*9+2)
.long virtw*spritew*(10*9+3)
.long virtw*spritew*(10*9+4)
.long virtw*spritew*(10*9+5)
.long virtw*spritew*(10*9+6)
.long virtw*spritew*(10*9+7)
.long virtw*spritew*(10*9+8)
.long virtw*spritew*(11*9+0)
.long virtw*spritew*(11*9+1)
.long virtw*spritew*(11*9+2)
.long virtw*spritew*(11*9+3)
.long virtw*spritew*(11*9+4)
.long virtw*spritew*(11*9+5)
.long virtw*spritew*(11*9+6)
.long virtw*spritew*(11*9+7)
.long virtw*spritew*(11*9+8)
.long virtw*spritew*(12*9+0)
.long virtw*spritew*(12*9+1)
.long virtw*spritew*(12*9+2)
.long virtw*spritew*(12*9+3)
.long virtw*spritew*(12*9+4)
.long virtw*spritew*(12*9+5)
.long virtw*spritew*(12*9+6)
.long virtw*spritew*(12*9+7)
.long virtw*spritew*(12*9+8)
.long virtw*spritew*(13*9+0)
.long virtw*spritew*(13*9+1)
.long virtw*spritew*(13*9+2)
.long virtw*spritew*(13*9+3)
.long virtw*spritew*(13*9+4)
.long virtw*spritew*(13*9+5)
.long virtw*spritew*(13*9+6)
.long virtw*spritew*(13*9+7)
.long virtw*spritew*(13*9+8)
.long virtw*spritew*(14*9+0)
.long virtw*spritew*(14*9+1)
.long virtw*spritew*(14*9+2)
.long virtw*spritew*(14*9+3)
.long virtw*spritew*(14*9+4)
.long virtw*spritew*(14*9+5)
.long virtw*spritew*(14*9+6)
.long virtw*spritew*(14*9+7)
.long virtw*spritew*(14*9+8)
.long virtw*spritew*(15*9+0)
.long virtw*spritew*(15*9+1)
.long virtw*spritew*(15*9+2)
.long virtw*spritew*(15*9+3)
.long virtw*spritew*(15*9+4)
.long virtw*spritew*(15*9+5)
.long virtw*spritew*(15*9+6)
.long virtw*spritew*(15*9+7)
.long virtw*spritew*(15*9+8)
.long virtw*spritew*(16*9+0)
.long virtw*spritew*(16*9+1)
.long virtw*spritew*(16*9+2)
.long virtw*spritew*(16*9+3)
.long virtw*spritew*(16*9+4)
.long virtw*spritew*(16*9+5)
.long virtw*spritew*(16*9+6)
.long virtw*spritew*(16*9+7)
.long virtw*spritew*(16*9+8)
.long virtw*spritew*(17*9+0)
.long virtw*spritew*(17*9+1)
.long virtw*spritew*(17*9+2)
.long virtw*spritew*(17*9+3)
.long virtw*spritew*(17*9+4)
.long virtw*spritew*(17*9+5)
.long virtw*spritew*(17*9+6)
.long virtw*spritew*(17*9+7)
.long virtw*spritew*(17*9+8)
.long virtw*spritew*(18*9+0)
.long virtw*spritew*(18*9+1)
.long virtw*spritew*(18*9+2)
.long virtw*spritew*(18*9+3)
.long virtw*spritew*(18*9+4)
.long virtw*spritew*(18*9+5)
.long virtw*spritew*(18*9+6)
.long virtw*spritew*(18*9+7)
.long virtw*spritew*(18*9+8)
.long virtw*spritew*(19*9+0)
.long virtw*spritew*(19*9+1)
.long virtw*spritew*(19*9+2)
.long virtw*spritew*(19*9+3)
.long virtw*spritew*(19*9+4)
.long virtw*spritew*(19*9+5)
.long virtw*spritew*(19*9+6)
.long virtw*spritew*(19*9+7)
.long virtw*spritew*(19*9+8)
.long virtw*spritew*(20*9+0)
.long virtw*spritew*(20*9+1)
.long virtw*spritew*(20*9+2)
.long virtw*spritew*(20*9+3)
.long virtw*spritew*(20*9+4)
.long virtw*spritew*(20*9+5)
.long virtw*spritew*(20*9+6)
.long virtw*spritew*(20*9+7)
.long virtw*spritew*(20*9+8)
.long virtw*spritew*(21*9+0)
.long virtw*spritew*(21*9+1)
.long virtw*spritew*(21*9+2)
.long virtw*spritew*(21*9+3)
.long virtw*spritew*(21*9+4)
.long virtw*spritew*(21*9+5)
.long virtw*spritew*(21*9+6)
.long virtw*spritew*(21*9+7)
.long virtw*spritew*(21*9+8)
.long virtw*spritew*(22*9+0)
.long virtw*spritew*(22*9+1)
.long virtw*spritew*(22*9+2)
.long virtw*spritew*(22*9+3)
.long virtw*spritew*(22*9+4)
.long virtw*spritew*(22*9+5)
.long virtw*spritew*(22*9+6)
.long virtw*spritew*(22*9+7)
.long virtw*spritew*(22*9+8)
.long virtw*spritew*(23*9+0)
.long virtw*spritew*(23*9+1)
.long virtw*spritew*(23*9+2)
.long virtw*spritew*(23*9+3)
.long virtw*spritew*(23*9+4)
.long virtw*spritew*(23*9+5)
.long virtw*spritew*(23*9+6)
.long virtw*spritew*(23*9+7)
.long virtw*spritew*(23*9+8)
.long virtw*spritew*(24*9+0)
.long virtw*spritew*(24*9+1)
.long virtw*spritew*(24*9+2)
.long virtw*spritew*(24*9+3)
.long virtw*spritew*(24*9+4)
.long virtw*spritew*(24*9+5)
.long virtw*spritew*(24*9+6)
.long virtw*spritew*(24*9+7)
.long virtw*spritew*(24*9+8)
.long virtw*spritew*(25*9+0)
.long virtw*spritew*(25*9+1)
.long virtw*spritew*(25*9+2)
.long virtw*spritew*(25*9+3)
.long virtw*spritew*(25*9+4)
.long virtw*spritew*(25*9+5)
.long virtw*spritew*(25*9+6)
.long virtw*spritew*(25*9+7)
.long virtw*spritew*(25*9+8)
.long virtw*spritew*(26*9+0)
.long virtw*spritew*(26*9+1)
.long virtw*spritew*(26*9+2)
.long virtw*spritew*(26*9+3)
.long virtw*spritew*(26*9+4)
.long virtw*spritew*(26*9+5)
.long virtw*spritew*(26*9+6)
.long virtw*spritew*(26*9+7)
.long virtw*spritew*(26*9+8)
.long virtw*spritew*(27*9+0)
.long virtw*spritew*(27*9+1)
.long virtw*spritew*(27*9+2)
.long virtw*spritew*(27*9+3)
.long virtw*spritew*(27*9+4)
.long virtw*spritew*(27*9+5)
.long virtw*spritew*(27*9+6)
.long virtw*spritew*(27*9+7)
.long virtw*spritew*(27*9+8)
.long virtw*spritew*(28*9+0)
.long virtw*spritew*(28*9+1)
.long virtw*spritew*(28*9+2)
.long virtw*spritew*(28*9+3)
.long virtw*spritew*(28*9+4)
.long virtw*spritew*(28*9+5)
.long virtw*spritew*(28*9+6)
.long virtw*spritew*(28*9+7)
.long virtw*spritew*(28*9+8)
.long virtw*spritew*(29*9+0)
.long virtw*spritew*(29*9+1)
.long virtw*spritew*(29*9+2)
.long virtw*spritew*(29*9+3)
.long virtw*spritew*(29*9+4)
.long virtw*spritew*(29*9+5)
.long virtw*spritew*(29*9+6)
.long virtw*spritew*(29*9+7)
.long virtw*spritew*(29*9+8)
.long virtw*spritew*(30*9+0)
.long virtw*spritew*(30*9+1)
.long virtw*spritew*(30*9+2)
.long virtw*spritew*(30*9+3)
.long virtw*spritew*(30*9+4)
.long virtw*spritew*(30*9+5)
.long virtw*spritew*(30*9+6)
.long virtw*spritew*(30*9+7)
.long virtw*spritew*(30*9+8)
.long virtw*spritew*(31*9+0)
.long virtw*spritew*(31*9+1)
.long virtw*spritew*(31*9+2)
.long virtw*spritew*(31*9+3)
.long virtw*spritew*(31*9+4)
.long virtw*spritew*(31*9+5)
.long virtw*spritew*(31*9+6)
.long virtw*spritew*(31*9+7)
.long virtw*spritew*(31*9+8)

/*
ddmulttable:            # probably better way to write this...
	irp     <0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31>,@m41
	irp     <0,1,2,3,4,5,6,7,8>,@m42
	.long   virtw*spritew*(@m41*9+@m42)
	endm
	endm
*/
#_data  ends

#*********************************************************************
# code
#*********************************************************************

.text   
#       assume  %cs:_text,%ds:_data,%es:_data

#*********************************************************************
# macros
#*********************************************************************

/* MACRO!
#*********************************************************************
# trans_move
#       does a transparent move from source to dest of 4 bytes.
#*********************************************************************
	trans_move      source,macro    dest
	mov     source,%eax
	mov     %eax,%edx
	subb    $1,%dl
	sbbb    %dl,%dl         # set dl to carry.
	subb    $1,%dh
	sbbb    %dh,%dh
	rol     $16,%edx
 
#       bswap edx               ; faster, but screws 386s.
	subb    $1,%dl
	sbbb    %dl,%dl
	subb    $1,%dh
	sbbb    %dh,%dh
	rol     $16,%edx
#       bswap edx
	and     dest,%edx
	or      %edx,%eax
	mov     %eax,dest
	endm
*/

#*********************************************************************
# functions
#*********************************************************************

#*********************************************************************
# randomdelta
#  sets eax to a random delta.
# this generator was ripped from bc++ 3.0
#*********************************************************************
randomdelta:    #proc
	push    %edx   
	push    %ecx     
	push    %ebx
	mov     $0x15a4e35,%ecx
	mov     random,%eax
	mul     %ecx
	shrd    $16,%edx,%eax
	inc     %eax
	mov     %eax,%ebx               # top 16 random...
	mul     %ecx
	shrd    $16,%edx,%eax
	inc     %eax
	mov     %eax,random
	shrd    $16,%edx,%ebx
	mov     %ebx,%eax
	pop     %ebx   
	pop     %ecx     
	pop     %edx
	ret
#randomdelta    endp

#*********************************************************************
# FEASM_SetGraph - called with
#       v FEASM_SetGraph(int mode);
#                                         eax
# tbd: make vesa compliant.
#*********************************************************************
_FEASM_SetGraph:        #proc
	mov     4(%esp),%eax
	int     $0x10
	ret
#_FEASM_SetGraph        endp

#*********************************************************************
# FEASM_Init - called with
#       v FEASM_Init(char *x, char *ylookup, char *keytable);
#                                 eax                   edx                     ebx
#*********************************************************************
_FEASM_Init:    #proc
	mov     4(%esp),%eax
	push    %ebx    
	push    %edx
	mov     16(%esp),%edx
	mov     20(%esp),%ebx
	mov     %eax,xlookup
	mov     %edx,ylookup
	mov     %ebx,keytable
# save the ds so anyone can get it:
	push    %eax    
	push    %ebx     
	push    %ecx    
	push    %es
	xor     %ebx,%ebx
	movw    %cs,%bx
	mov     $0x0a,%eax              # create alias.
	int     $0x31
	# should jump off on error (cf set)
	movw    %ds,%bx
	movw    %ax,%es
	mov     $ourds,%ecx
	movw    %bx,%es:(%ecx)
	pop     %es
	# free selector:
	mov     %eax,%ebx
	mov     $1,%eax
	int     $0x31
	# again, check error code.
	pop     %ecx    
	pop     %ebx     
	pop     %eax
# done...
# should hook vectors:
	push    %esi    
	push    %edi     
	push    %ebx    
	push    %ecx     
	push    %es
	mov     $0x3409,%eax
	int     $0x21                                   # get old int into es:bx
	mov     %es,oldkeyseg
	mov     %ebx,oldkeyoff
	pop     %es
	mov     keytable,%edi
	xor     %eax,%eax
	mov     $32,%ecx
	rep     
	stosl                           # clear interrup table. 
	mov     $0x2509,%eax
	mov     int9,%edx
	push    %ds     
	push    %cs
	pop     %ds
	int     $0x21                                   # set the vector.
	pop     %ds
# should now set the ticker & reset its speed...
	pop     %ecx    
	pop     %ebx     
	pop     %edi    
	pop     %esi
	pop     %edx    
	pop     %ebx
	ret
#_FEASM_Init    endp

#*********************************************************************
# FEASM_ShutDown - called with
#       v FEASM_ShutDown();
#*********************************************************************
_FEASM_ShutDown:        #proc
	push    %eax    
	push    %edx     
	push    %ecx    
	push    %ebx     
	push    %es     
	push    %ds
	mov     oldkeyoff,%edx
	mov     oldkeyseg,%ds
	mov     $0x2509,%eax
	int     $0x21                                   # reset int handler.
	pop     %ds     
	pop     %es      
	pop     %ebx    
	pop     %ecx     
	pop     %edx    
	pop     %eax
	ret
#_FEASM_ShutDown        endp

# ugly, but works:
ourds:  .value  0

#*********************************************************************
# interrupt handlers:  pretty self evident.
#*********************************************************************
int9:   #proc
	push    %eax    
	push    %edx    
	push    %ecx    
	push    %ebx 
	push    %ds
# get data segment:
	movw    %cs:ourds,%ax
	movw    %ax,%ds
	# get scan code & control:
	inb     $0x60,%al
/*
# debug:
	mov     $0x0b0000,%ebx
	incb    (%ebx)
	movb    %al,2(%ebx)
# end debug */
	xor     %ebx,%ebx
	movb    %al,%bl         # save scan code.
	xchgb   %ah,%al
	orb     $0x80,%al               # set keyboard acknowledge...
	incw    %dx
	outb    %al,%dx         # acknowledge keypress!
	testb   $0x80,%bl       # is it release?
	jnz     zerocharacter
	add     keytable,%ebx
	movb    $1,(%ebx)               # char is pressed.
	jmp     skip143
	zerocharacter:
	andb    $0x7f,%bl
	add     keytable,%ebx
	movb    $0,(%ebx)
	skip143:
# reset keyboard:
	inb     $0x61,%al
	orb     $0x80,%al
	outb    %al,$0x61
	andb    $0x7f,%al
	outb    %al,$0x61
	movb    $0x20,%al                       # send generic eoi to pic.
	outb    %al,$0x20
	pop     %ds     
	pop     %ebx    
	pop     %ecx    
	pop     %edx    
	pop     %eax
	iretl                           # pus... wasted half an hour before i noticed this :>
 /* int9  endp  nb: how can you get watcom debugger to save it's */
 /* # interrupts so you don't lose the kbd?? */

#*********************************************************************
# FEASM_DrawSquare - called as
#       v FEASM_DrawSquare(char *dest, int w, int h);
#                                                eax        edx    ebx
#  fills in a black rectangle centred at dest, of wxh dimmensions.
#*********************************************************************
_FEASM_DrawSquare:      #proc
	mov     4(%esp),%eax
	push    %edx    
	push    %ebx
	mov     16(%esp),%edx
	mov     20(%esp),%ebx

	push    %ecx    
	push    %edi
	mov     %eax,%edi
	add     $3,%edx
	shr     $1,%edx
	sub     %edx,%edi
	shr     $1,%edx
	mov     %ebx,%eax
	shr     $1,%eax
	sub     $ddmulttable(,%eax,4),%edi
	xor     %eax,%eax
	startloop231:
	push    %edi            # ugh...
	mov     %edx,%ecx
	rep
	stosl
	pop     %edi
	add     virtw*spritew,%edi
	dec     %ebx
	jnz     startloop231
	pop     %edi    
	pop     %ecx
	pop     %ebx    
	pop     %edx
	ret
#_FEASM_DrawSquare      endp

/*
#*********************************************************************
# FEASM_DrawTransSquare - called as
#       v FEASM_DrawTransSquare(char *dest, char *source);
#                       eax                     edx
# not used now.  draws a transparent square.  could be adapted form
# blitting transparent objects (though allignment checks, at 3 cycles
# per misallignment, are a must :>)
#*********************************************************************
_FEASM_DrawTransSquare: #proc
	mov     4(%esp),%eax
	mov     8(%esp),%edx
	push    %esi    
	push    %edi
	mov     %edx,%esi
	mov     %eax,%edi
	rept    spriteh
		# should be dependent upon spritew
	irp     <0,4,8,12,16,20,24,28>,@m130
	trans_move      @m130(%esi),@m130(%edi)
	endm
	add     spritew,%esi
	add     spritew*virtw,%edi
	endm
	pop     %edi    
	pop     %esi
	ret
#_FEASM_DrawTransSquare endp
*/

#*********************************************************************
# FEASM_BlitScreen - called with
#  v FEASM_BlitScreen(char *dest, char *source, int skip);
#                        eax         edx         ebx
#*********************************************************************
_FEASM_BlitScreen:      #proc
	mov     4(%esp),%eax
	push    %edx    
	push    %ebx
	mov     16(%esp),%edx
	mov     20(%esp),%ebx

	push    %esi    
	push    %edi     
	push    %ecx
	mov     %eax,%edi
	mov     %edx,%esi
	mov     $200,%eax               # should be made generic.
	loop225:
	mov     $80,%ecx
	rep
	movsl
	add     %ebx,%esi
	dec     %eax
	jnz     loop225
	pop     %ecx    
	pop     %edi    
	pop     %esi
	pop     %ebx    
	pop     %edx
	ret
#_FEASM_BlitScreen      endp

#*********************************************************************
# FEASM_InitStars(int seed, int numstar, int *stardata);
#                  eax           edx         ebx
#  randomizes positions & speeds of all stars.
#*********************************************************************
_FEASM_InitStars:       #proc
	mov     4(%esp),%eax
	push    %ebx    
	push    %edx
	mov     16(%esp),%ebx
	mov     20(%esp),%edx

	push    %esi    
	push    %edi     
	push    %ecx
	mov     %edx,%ecx
	mov     %ebx,%esi
	add     $8,%esi
	mov     %eax,random
	startloop292:
	call    randomdelta
	xor     %edx,%edx
	mov     virtw*spritew*65536,%ebx
	div     %ebx
	mov     %edx,(%esi)                     # x
	call    randomdelta
	xor     %edx,%edx
	mov     virth*spritew*65536,%ebx
	div     %ebx
	mov     %edx,4(%esi)            # y
	call    randomdelta
	and     $0x03ffff,%eax
	mov     %eax,8(%esi)            # speed
	shr     $14,%eax
	add     $16,%eax
	mov     %eax,12(%esi)           # colour.
	add     $16,%esi
	dec     %ecx
	jnz     startloop292
	pop     %ecx    
	pop     %edi    
	pop     %esi
	pop     %edx    
	pop     %ebx
	ret
#_FEASM_InitStars       endp

#*********************************************************************
# FEASM_MoveStars(int dest, int numstar, int *stardata);
#                  eax        edx              ebx
# star format:
#   header: dd dx, dy
#   element:dd x, y, speed, colour
# nb: not perfect, a trailing star can be masked by a leading one, but
# to avoid this would take two passes which would probably not be worth it.
# problems in vesa: keep stars in seperate banks: crossovers should be throwns
# on a crossover stack for dealing with afterwards.
#*********************************************************************
_FEASM_MoveStars:       #proc
	mov     4(%esp),%eax
	push    %edx    
	push    %ebx
	mov     16(%esp),%edx
	mov     20(%esp),%ebx

	push    %esi    
	push    %edi     
	push    %ecx    
	push    %ebp
	mov     %eax,%edi
	mov     %ebx,%esi
	mov     %edx,%ecx
	mov     (%esi),%ebx                     # dx
	mov     4(%esi),%ebp            # dy
	add     $8,%esi
	jmp     looptest265
	startloop266:
	mov     4(%esi),%edx    # y
	mov     (%esi),%eax             # x
	shr     $16,%edx
	shr     $16,%eax
	add     $ddmulttable(,%edx,4),%eax      # offset of star... 
	movb    $0,(%edi,%eax)  # clear star... (agi!)
		# update star pos
		/* tbd  optimize for jmp pred. if req'd. */
	mov     8(%esi),%eax    # speed.
	imul    %ebx                    # dx...
	shld    $16, %eax, %edx # actual dx...
	add     (%esi),%edx             # x
	jns     skip282
			# negative:
	add     virtw*spritew*65536,%edx
	call    randomdelta
	and     $0x03ffff,%eax
	mov     %eax,8(%esi)            # new dy.
	shr     $14,%eax                                # brighter: closer. gives 0-16.
	add     $16,%eax
	mov     %eax,12(%esi)           # new colour.
	skip282:
	cmp     virtw*spritew*65536,%edx
	jb      skip287
	sub     virtw*spritew*65536,%edx
	call    randomdelta
	and     $0x03ffff,%eax
	mov     %eax,8(%esi)            # new dy.
	shr     $14,%eax                                # brighter: closer. gives 0-16.
	add     $16,%eax
	mov     %eax,12(%esi)           # new colour.
	skip287:
	mov     %edx,(%esi)                     # save x...
		# now y:
	mov     8(%esi),%eax            # speed.
	imul    %ebp                            # dy
	shld    $16,%eax,%edx
	add     4(%esi),%edx                    # y.
	jns     skip302
	add     virth*spriteh*65536,%edx
	call    randomdelta
	and     $0x03ffff,%eax
	mov     %eax,8(%esi)            # new dy.
	shr     $14,%eax                                # brighter: closer. gives 0-16.
	add     $16,%eax
	mov     %eax,12(%esi)           # new colour.
	skip302:
	cmp     virth*spriteh*65536,%edx
	jb      skip311
	sub     virth*spriteh*65536,%edx
	call    randomdelta
	and     $0x03ffff,%eax
	mov     %eax,8(%esi)            # new dy.
	shr     $14,%eax                                # brighter: closer. gives 0-16.
	add     $16,%eax
	mov     %eax,12(%esi)           # new colour.
	skip311:
	mov     %edx,4(%esi)
		# write new star at current pos:
	mov     (%esi),%eax
	mov     4(%esi),%edx
	shr     $16,%edx
	shr     $16,%eax
	add     $ddmulttable(,%edx,4),%eax
	mov     12(%esi),%edx
	movb    %dl,(%edi,%eax)
		# finish:
	add     $16,%esi
	looptest265:
	dec     %ecx
	jnz     startloop266
	pop     %ebp    
	pop     %ecx    
	pop     %edi    
	pop     %esi
	pop     %ebx    
	pop     %edx
	ret
#_FEASM_MoveStars       endp

#*********************************************************************
# FEASM_DrawRotated - called with
#       v FEASM_DrawRotated(int dest, int source, int *edgedata
#                                                eax            edx                             ebx
# does a simplified t-mapper using precompiled edge data.
# there appears to be an offby one error either in here or in the
# edge data compiler...
#   times are measured in 32x32 ships per 20 seconds.
#  not unrolled, w# pushes: 117053.
#  unrolled by 4, w# pushes: 130657.
#  unrolled by 4, removed transparcency jump: ~43000: ouch!!!
#*********************************************************************
_FEASM_DrawRotated:     #proc
	mov     4(%esp),%eax
	push    %edx    
	push    %ebx
	mov     16(%esp),%edx
	mov     20(%esp),%ebx
	push    %esi    
	push    %edi     
	push    %ecx    
	push    %ebp

	# set up:
	# set proper destination:
	mov     %eax,%edi
	mov     4(%ebx),%eax    # height
	shr     $1,%eax
	mov     $ddmulttable(,%eax,4),%eax
	add     %eax,%eax
	add     (%ebx),%eax             # width
	shr     $1,%eax
	sub     %eax,%edi
	# set up source:
	mov     %edx,%esi
	# set up increments:
	movw    10(%ebx),%ax
	cwde
	mov     %eax,%ebp               # high dxx.
	mov     6(%ebx),%eax    # load high eax with low cos.
	movw    13(%ebx),%ax    # ah = lowhigh byte of sin, al = high low.
	# get past header.
	add     $16,%ebx
	# set up y loop vars:
	mov     -12(%ebx),%ecx  # height.
# argh.. this loop is disgustingly unefficient...
	startloop290:
	push    %edi    
	push    %esi     
	push    %ebx    
	push    %ecx     # should store or s-m or something else.
	add     (%ebx),%esi
	add     8(%ebx),%edi
	mov     12(%ebx),%ecx
	mov     %ecx,%edx
	add     $3,%ecx
	and     $3,%edx
	shr     $2,%ecx
	jmpl    jumptable520(,%edx,4)

jump0table520: 
	mov     4(%ebx),%edx
	xor     %ebx,%ebx
	jcxz    end314                          # occasionaly, really is zero!
	jmp     unrolled0loop275
jump1table520:
	mov     4(%ebx),%edx
	xor     %ebx,%ebx
	sub     $3,%edi
	jmp     unrolled1loop275
jump2table520:
	mov     4(%ebx),%edx
	xor     %ebx,%ebx
	sub     $2,%edi
	jmp     unrolled2loop275
jump3table520:
	mov     4(%ebx),%edx
	xor     %ebx,%ebx
	dec     %edi
	jmp     unrolled3loop275

	startloop275:
unrolled0loop275:
	add     %eax,%edx
	movb    (%esi,%ebx),%bh         # no agi - hahaha!!!
	adc     %ebp,%esi
	orb     %bh,%bh
	jz      skip270
	movb    %bh,(%edi)
	skip270:
	movb    %dh,%bh
unrolled3loop275:
	add     %eax,%edx
	movb    (%esi,%ebx),%bh         # no agi.
	adc     %ebp,%esi
	orb     %bh,%bh
	jz      skip566
	movb    %bh,1(%edi)
	skip566:
	movb    %dh,%bh
unrolled2loop275:
	add     %eax,%edx
	movb    (%esi,%ebx),%bh         # no agi.
	adc     %ebp,%esi
	orb     %bh,%bh
	jz      skip575
	movb    %bh,2(%edi)
	skip575:
	movb    %dh,%bh
unrolled1loop275:
	add     %eax,%edx
	movb    (%esi,%ebx),%bh         # no agi.
	adc     %ebp,%esi
	orb     %bh,%bh
	jz      skip584
	movb    %bh,3(%edi)
	skip584:
	movb    %dh,%bh
# end...
	add     $4,%edi
	dec     %ecx
	jnz     startloop275
	end314:
	pop     %ecx    
	pop     %ebx     
	pop     %esi    
	pop     %edi
	add     $16,%ebx
	add     virtw*spritew,%edi
#               add edi, 320
	dec     %ecx
	jnz     startloop290
	# should now be done...
	pop     %ebp    
	pop     %ecx    
	pop     %edi    
	pop     %esi
	pop     %ebx    
	pop     %edx
	ret
#FEASM_DrawRotated_     endp

#end


 
